;|								;;
		REVCLOUD to Block  v.1.0			;;
		By: Andrea Andreetti 2009-02-13			|;
;;	(RC2Block "BlockName" color)
;;test:	(RC2Block "3" 4)
;;test: (RC2Block "tt" 2)

(princ "\nRC2Block v.1.0   By: Andrea Andreetti 2009-02-13")
(vl-load-com)
(defun rc2block (blockname _coul / vla_revcloudE coord coordLen r2b_datax)  
  (setq revcloud nil)
  (while (not revcloud)
    (setq revcloud_e (car (entsel)))
    (setq vla_revcloude (vlax-ename->vla-object revcloud_e))
    (if (eq (vla-get-objectname vla_revcloude) "AcDbPolyline")
      (setq revcloud t)
    )
  )
  (setq coordlen (vl-list-length
                   (setq coord (vlax-safearray->list
                                 (vlax-variant-value (vla-get-coordinates vla_revcloude))
                               )
                   )
                 )
  )
  (vl-cmdf "._-insert"
           blockname
           (setq fp (list (nth 0 coord) (nth 1 coord)))
           1
           1
           0
  )
  
  (setq r2b_datax (entget (setq r2b_item (entlast))))
  (if r2b_item
    (progn (entdel r2b_item) (setq r2b_item nil))
  )
  (repeat (/ coordlen 2)
    (setq _ip (list (nth 0 coord) (nth 1 coord)))
    (if (>= (vl-list-length coord) 4)
      (progn (setq _dx (distance (list (nth 0 coord) (nth 1 coord))
                                 (list (nth 2 coord) (nth 3 coord))
                       )
             )
             (setq _an (angle (list (nth 0 coord) (nth 1 coord))
                              (list (nth 2 coord) (nth 3 coord))
                       )
             )
      )
      (progn (setq nc coord)
             (setq _dx (distance coord fp))
             (setq _an (angle coord fp))
      )
    )
    (if _coul
      (if (> _coul 254)
        (setq _coul 1)
        (setq _coul (1+ _coul))
      )
    )
    (r2binsertblock blockname _ip _dx _dx _an _coul)
    (setq coord (cddr coord))
  )
  (if revcloud_e
    (progn (entdel revcloud_e) (setq revcloud_e nil))
  )
)



(defun r2binsertblock (bname ip dx dy an coul / bent)
  (setq r2b_datax (subst (cons 2 bname) (assoc 2 r2b_datax) r2b_datax))
  (setq r2b_datax (subst (cons 10 ip) (assoc 10 r2b_datax) r2b_datax))
  (setq r2b_datax (subst (cons 41 dx) (assoc 41 r2b_datax) r2b_datax))
  (setq r2b_datax (subst (cons 42 dy) (assoc 42 r2b_datax) r2b_datax))
  (setq r2b_datax (subst (cons 50 an) (assoc 50 r2b_datax) r2b_datax))
  (if coul
    (if (not (assoc 62 r2b_datax))
      (setq r2b_datax (append r2b_datax (list (cons 62 coul))))
      (setq r2b_datax (subst (cons 62 coul) (assoc 62 r2b_datax) r2b_datax))
    )
  )
  (entmake r2b_datax)  
)

